
socket = require 'socket'

print()
print('LuaSocket Version: ' .. socket._VERSION)

serv = socket.tcp()
serv:setoption("reuseaddr", true)
serv:settimeout(5)
serv:bind("*", 9797)
serv:listen(1)

client = {
	socket = socket.tcp()
}
client.socket:settimeout(0)

function client.receive()
	local packet = ''
	local data, _, partial = client.socket:receive(8192)
	while data do
		packet = packet .. data
		data, _, partial = client.socket:receive(8192)
	end
	if not data and partial then
		packet = packet .. partial
	end
	if packet ~= '' then
		return packet
	end
	return nil, 'No messages'
end

client.socket:settimeout(5)
client.socket:connect("127.0.0.1", 9797, false)
client.socket:settimeout(0)

c = serv:accept()

c:send("hellothere")
socket.sleep(0.1)

msg = client.receive()
print("Message: " .. msg)
assert(msg == "hellothere")

serv:close()
client.socket:close()
